//
//  ItemEditViewController.m
//  ShopperChecker
//
//  Created by Felix Wang on 20/12/10.
//  Copyright 2010 Felix Wang. All rights reserved.
//

#import "ItemEditViewController.h"


@implementation ItemEditViewController
@synthesize itemName, itemDescription;


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	self.navigationItem.title = @"New Item";
	self.itemDescription.layer.cornerRadius = 5;
	self.itemDescription.layer.borderWidth = 1;
	self.itemDescription.layer.borderColor = [[UIColor lightGrayColor] CGColor];
	self.itemDescription.clipsToBounds = YES;
}

- (void)viewWillAppear:(BOOL)animated {
	[self.itemName becomeFirstResponder];
}

- (void)viewDidAppear:(BOOL)animated {
	UIBarButtonItem *saveButton = [[UIBarButtonItem alloc] initWithTitle:@"Save" style:UIBarButtonItemStylePlain target:self action:@selector(saveItem:)];
	self.navigationItem.rightBarButtonItem = saveButton;
	[saveButton release];
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[itemName release];
	[itemDescription release];
    [super dealloc];
}

#pragma mark Custom	Methods

-(void)saveItem:(id)sender {
	//Get the application delegate
	ShopperCheckerAppDelegate *appDelegate = (ShopperCheckerAppDelegate *)[[UIApplication sharedApplication] delegate];
	
	NSManagedObjectContext *context = [appDelegate managedObjectContext];
	
	NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
	NSEntityDescription *entity = [NSEntityDescription entityForName:@"ShoppingList"
											  inManagedObjectContext:context];
	
	NSPredicate *predicate = [NSPredicate predicateWithFormat:@"name=%@",itemName.text];
	
	[fetchRequest setPredicate:predicate];
	
	[fetchRequest setEntity:entity];
	NSError *error;
	NSArray *sameItems = [context executeFetchRequest:fetchRequest error:&error];
	
	[fetchRequest release];
	
	if ([sameItems count]>0) {
		ShoppingList *shoppingItem = [sameItems objectAtIndex:0];
		shoppingItem.desc = itemDescription.text;
		shoppingItem.checked = @"NO";
		shoppingItem.status = @"ON";
		NSError *error;
		if (![context save:&error]) {
			NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
		}	
	} else {
		if ([itemName.text length] > 0) {
			//Store the new shopping item in CoreData
			ShoppingList *shoppingItem = [NSEntityDescription 
										  insertNewObjectForEntityForName:@"ShoppingList"
										  inManagedObjectContext:context];
			shoppingItem.name = itemName.text;
			shoppingItem.desc = itemDescription.text;
			NSError *error;
			if (![context save:&error]) {
				NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
			}				
		}
}
	[self.navigationController popViewControllerAnimated:YES]; 
}


@end
