//
//  ListViewController.h
//  ShopperChecker
//
//  Created by Felix Wang on 13/12/10.
//  Copyright 2010 Felix Wang. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreData/CoreData.h>
#import "ShoppingList.h"
#import "ShopperCheckerAppDelegate.h"
#import "ItemEditViewController.h"
#import "ItemDetailViewController.h"


@interface ListViewController : UIViewController <UITableViewDelegate, UITableViewDataSource, NSFetchedResultsControllerDelegate, UISearchBarDelegate> {
	
	UITableView *tblView;
	UISearchBar *sBar;
		
	//CoreData
	NSFetchedResultsController *fetchedResultsController;
	NSManagedObjectContext *managedObjectContext;
	
	//NSArray *shoppingList;
	NSMutableArray *searchedShoppingList;
	
	ItemEditViewController *itemEditViewController;
	ItemDetailViewController *itemDetailViewController;

}
@property (nonatomic, retain) IBOutlet UITableView *tblView;
@property (nonatomic, retain) IBOutlet UISearchBar *sBar;

@property (nonatomic, retain) IBOutlet ItemEditViewController *itemEditViewController;
@property (nonatomic, retain ) IBOutlet ItemDetailViewController *itemDetailViewController;

//CoreData
@property (nonatomic, retain) NSFetchedResultsController *fetchedResultsController;
@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;

//@property (nonatomic, retain) NSArray *shoppingList;
@property (nonatomic, retain) NSMutableArray *searchedShoppingList;

//Custom methods
-(void)newShoppingItem:(id)sender;
-(NSArray *)getAllItems;
-(NSArray *)getItemByName:(NSString *)itemName;

@end
