//
//  ShopperCheckerAppDelegate.m
//  ShopperChecker
//
//  Created by Felix Wang on 13/12/10.
//  Copyright 2010 Felix Wang. All rights reserved.
//

#import "ShopperCheckerAppDelegate.h"


@implementation ShopperCheckerAppDelegate

@synthesize window;
@synthesize tabBarController;
@synthesize managedObjectContext;


#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    
    // Override point for customization after application launch.
	
	NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
	NSEntityDescription *entity = [NSEntityDescription entityForName:@"ShoppingList"
											  inManagedObjectContext:self.managedObjectContext];
	NSPredicate *predicate = [NSPredicate predicateWithFormat:@"checked=%@ and status=%@", @"NO", @"ON"];
	[fetchRequest setPredicate:predicate];	[fetchRequest setEntity:entity];
	NSError *error;
	NSArray *selectedItems = [managedObjectContext executeFetchRequest:fetchRequest error:&error];
	[fetchRequest release];
	[[UIApplication sharedApplication] setApplicationIconBadgeNumber:[selectedItems count]];
	

    // Add the tab bar controller's view to the window and display.
    [window addSubview:tabBarController.view];
    [window makeKeyAndVisible];
    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
	NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
	NSEntityDescription *entity = [NSEntityDescription entityForName:@"ShoppingList"
											  inManagedObjectContext:self.managedObjectContext];
	NSPredicate *predicate = [NSPredicate predicateWithFormat:@"checked=%@ and status=%@", @"NO", @"ON"];
	[fetchRequest setPredicate:predicate];
	[fetchRequest setEntity:entity];
	NSError *error;
	NSArray *selectedItems = [managedObjectContext executeFetchRequest:fetchRequest error:&error];
	[fetchRequest release];
	[[UIApplication sharedApplication] setApplicationIconBadgeNumber:[selectedItems count]];
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}


- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
	NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
	NSEntityDescription *entity = [NSEntityDescription entityForName:@"ShoppingList"
											  inManagedObjectContext:self.managedObjectContext];
	NSPredicate *predicate = [NSPredicate predicateWithFormat:@"checked=%@ and status=%@", @"NO", @"ON"];
	[fetchRequest setPredicate:predicate];
	[fetchRequest setEntity:entity];
	NSError *error;
	NSArray *selectedItems = [managedObjectContext executeFetchRequest:fetchRequest error:&error];
	[fetchRequest release];
	[[UIApplication sharedApplication] setApplicationIconBadgeNumber:[selectedItems count]];
}


#pragma mark -
#pragma mark UITabBarControllerDelegate methods

/*
// Optional UITabBarControllerDelegate method.
- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController {
}
*/

/*
// Optional UITabBarControllerDelegate method.
- (void)tabBarController:(UITabBarController *)tabBarController didEndCustomizingViewControllers:(NSArray *)viewControllers changed:(BOOL)changed {
}
*/


#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}

#pragma mark -
#pragma mark CoreData implementation
//Explicitly write CoreData accessors
-(NSManagedObjectModel *)managedObjectModel {
	if (managedObjectModel != nil) {
		return managedObjectModel;
	}
	managedObjectModel = [[NSManagedObjectModel mergedModelFromBundles:nil] retain];
	
	return managedObjectModel;
}

-(NSManagedObjectContext *) managedObjectContext {
	if (managedObjectContext != nil) {
		return managedObjectContext;
	}
	NSPersistentStoreCoordinator *coordinator = [self persistentStoreCoordinator];
	if (coordinator != nil) {
		managedObjectContext = [[NSManagedObjectContext alloc] init];
		[managedObjectContext setPersistentStoreCoordinator:coordinator];
	}
	return managedObjectContext;
	
}

-(NSPersistentStoreCoordinator *)persistentStoreCoordinator {
	if (persistentStoreCoordinator != nil) {
		return persistentStoreCoordinator;
	}
	NSURL *storeUrl = [NSURL fileURLWithPath:[[self applicationDocumentsDirectory]
											  stringByAppendingPathComponent:@"ShopperChecker.sqlite"]];
	NSError *error = nil;
	
	persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc]
								  initWithManagedObjectModel:[self managedObjectModel]];
	
	if (![persistentStoreCoordinator addPersistentStoreWithType:NSSQLiteStoreType
												  configuration:nil
															URL:storeUrl
														options:nil
														  error:&error]) {
		NSLog(@"Error: %@", error);
	}
	return persistentStoreCoordinator;
}

-(NSString *)applicationDocumentsDirectory {
	return [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject];
}

- (void)dealloc {
	[managedObjectModel release];
	[managedObjectContext release];
	[persistentStoreCoordinator release];
    [tabBarController release];
    [window release];
    [super dealloc];
}

@end

